/* Look at the today's calendar.   J_[ėp[eBeBER}h
     Program and file name: today.c

     @͂AȂƂ͎̂₵̂ŁAUNIX ̂悤ȃJ_[~
     Ȃ܂Bł FM-16/68000 v1.2 ŊJ܂Bƃ_
     TĈłAƂ̂͊̂łˁBX680x0 ł́A
     EBhEɂĕ\ƁAJ_[炵Ȃ܂B
     @ X680x0 p̃vOƂȂĂ܂Ǎꂼ
     ̂nr|X@ɍ킹ĕύX΁A啝ȕύXȂĂ\ł
     悤ɂȂĂ܂BǂAUNIX, cal CNR}hp
     B

     Copyright July, 1999,     Izumi Geotechnical Office inc.
          All rights reserved.   Kiso, Nagano prep, 399-6101, JAPAN
*/

#include  <stdio.h>           /* printf() */
#include  <string.h>          /* strcmp() */

#define   HELP      "-?"      /* ₢킹 */
#define   SIGN      "~~"      /*  */
#define   SPCSIZE   80        /* Xy[X̑傫 */
#define   OFF       0         /* tbO */
#define   ON        -1        /*   V@@ */
#define   STDIN     0         /* W̓pX */
#define   STDERR    2         /* WG[o̓pX */
#define   TYTLE     "ް"  /* X680x0 p */
#define   SPACE     "      "  /* \p */
#define   NSNTX     15        /* -? ̕\s */

struct set {
     short
          day,                /*  */
          month,              /*  */
          year,               /* N */
          week,               /* j̎n܂ʒu */
          last,               /* ̌̑S */
          disp;               /* \ */
} before, now, after,         /* 挎AA */
     this, *today;            /*  */

char
     *section = "\\\\\\\\\\";      /* 10 chars */
     *syntxcmt[NSNTX] = {
          "m\n",
          "\t 1.  today  [<߼>]",
          "\t 2.  today  [<N>]  [<>]",
          "[@\]",
          "\t  __ ŃJ_[Ɏ܂BUNIX  cal R}h",
          "\t łB\͕WG[o̓pXgĂ܂B",
          "\t @<N>݂̂w肷ƁAPN\܂B",
          "\t @@@A19?? ƃtNw肷邱ƁB",
          "\t @<>w肷ƁAOPƋɕ\܂B",
          "mIvVn",
          "\t -? : gp@\B",
          "\t -o :  \"@@N\" Wo̓pXɏo͂B",
          "\t -l : ̃J_[\B",
          "\t        -L: ^Cgo[ (X680x0) \B",
          "\t -n : ̕\so͂B"
     },
     *errcomment[6] = {
          "`̃IvV܂B",                 /* 1 */
          "-yNIvVɌ܂肪܂B",             /* 2 */
          "-mIvVɌ܂肪܂B",             /* 3 */
          "NA܂͌̐ݒl܂B",       /* 4 */
          "-o IvV<N>A<>ƕpł܂B",    /* 5 */
          "-o  -l IvV͓ɐݒł܂B"     /* 6 */
     };

short                         /* struct \̂ɍ킹 */
     nonflag,                 /* IvVLtbO */
     psopt,                   /* |[YIvV */
     outopt,                  /* ó@@@V@@ */
     lineopt,                 /* s@@@V@@ */
     wopt,                    /* ^Cg@V@@ */
     yopt,                    /* N@@@@V@@ */
     mopt,                    /* @@@@V@@ */
     x_axis;                  /* wWʒu */

int getlinesize(struct set *);
void getjulian(struct set *);
void subwork(short);
void calc(register struct set *);
void priout(void);
void priyear(short, short, int);
void priline(int, struct set *);
void subpri(int, int, struct set *);
int function(register struct set *);
int holiday(struct set *, register int);
void chkarg(int, char **);
void syntax(void);
int errorline(int);
void videoattr(int);
void cursorattr(int);

int main(int argc, char *argv[])
{
     int i;
     if (argc == 2 && strcmp(argv[1], HELP) == 0)
          syntax();
     else {
          chkarg(argc, argv);                /* ̉ */
          today = &this;
          getjulian(today);                  /* ݂̔N𓾂 */
          if (lineopt == ON) {
               calc(today);
               printf("%d\n", getlinesize(today) * 2 + 4);
          } else {
               if (outopt == OFF) {
                    if (yopt == ON) {        /* NwL */
                         now.year = yopt;
                         if (mopt == OFF) {  /* wȂ */
                              for (i = 2; i <= 11; i += 3)
                                   subwork(i);
                         } else
                              subwork(mopt);
                    } else {                 /* NwȂ */
                         now.year = today->year;  /* VXeNZbg */
                         subwork((mopt != OFF) ? mopt : today->month);
                    }
               } else
                    printf("%d  %d  %d\n",
                              today->month, today->day, today->year);
          }
     }
     return 0;
}

int getlinesize(struct set *pd)    /* \s𓾂 */
{
     int i,temp;
     temp = pd->last + pd->week - 1;
     i = temp / 7;
     if (temp % 7 != 0)
          i += 1;
     return i + 1;            /* Ps߂ */
}

void getjulian(struct set *pd)     /* ݂̔N𓾂 */
{
     union set1 {
          int a;
          short b;
          unsigned char c[4];
     } d;
     int dummy;
     short nweek;
     _sysdate(0, &dummy, &d.a, &nweek, &dummy);
     pd->year = d.b;               /* ^ϊ̂ */
     pd->month = d.c[2];
     pd->day = d.c[3];
}

void subwork(short i)    /* O㌎̌vZ */
{
     now.month = i;                /* \̐ݒ */
     /* ёO㌎̌vZ */
     calc(&now);                   /* ̃J_[lvZ */
     if (now.month == 1) {         /* 挎̋El */
          before.year = now.year - 1;
          before.month = 12;
     } else {
          before.year = now.year;
          before.month = now.month - 1;
     }
     if (nonflag == OFF) {         /* IvVL */
          calc(&before);           /* 挎̃J_[lvZ */
          if (now.month == 12) {   /* ̋El */
               after.year = now.year + 1;
               after.month = 1;
          } else {
               after.year = now.year;
               after.month = now.month + 1;
          }
          calc(&after);            /* ̃J_[lvZ */
     }
     priout();                     /* ʁiJ_[j̏o */
}

void calc(register struct set *pd)      /* NJ_[̍쐬 */
{
     /* NF@u}CRp`v^Ǎ pg.110 dqW]ʍ
                              a58N430sAVЊ */
     register int i,j;
     int dayptr;
     /* wN͐PNPP牽ځijH */
     dayptr = 1;              /* w͂̌̂PɌŒ肵ČvZ */
     i = (pd->month - 14) / 12;
     j = pd->year + i;
     j = (int)(j * 365.25) - j / 100 + j / 400;
     j += 367 * (pd->month - 2 - 12 * i) / 12 + 28 + dayptr;
     /* ̓ij͉jipd->weekjH */
     pd->week = j - (j / 7) * 7 + 1;
     /* 2Ȃ΁AN29Ȃ̔N28ɐݒ肵
        1,3,5,7,8,10,1231ɁȂ̌30ɐݒ肷B*/
     if (pd->month == 2)
          pd->last = (pd->year % 4 == 0 && pd->year % 100 != 0
                              || pd->year % 400 == 0) ? 29 : 28;
     else {
          i = pd->month - (pd->month / 2) * 2;
          if (pd->month > 7)
               i = 1 - i;
          pd->last = 30 + i;
     }
}

void priout(void)   /* J_[̕\ */
{
     int i,j,stop,
               winId;         /* for X680x0 personal window */
     char bf[2],space[SPCSIZE];
     if (wopt == ON) {        /* for X680x0 */
          winId = _pw_getsrvid(STDERR);
          _pw_name(STDERR, winId, MARK);
     }
     for (i = 0; i < SPCSIZE; i += 1)
          space[i] = ' ';
     stop = (nonflag == OFF) ? 3 : 1;
     fprintf(stderr, "\n");
     if (nonflag == OFF) {
          priyear(before.year, before.month, OFF);
          priyear(now.year, after.month, OFF);
          priyear(after.year, after.month, ON);
     } else
          priyear(now.year, now.month, ON);
     for (i = 0; i < stop; i += 1) {
          if (i > 0)
               fprintf(stderr, SPACE);
          fprintf(stderr, "%s", section);
     }
     fprintf(stderr, "\n");
     for (i = 0; i < stop; i += 1) {
          if (i > 0)
               fprintf(stderr, SPACE);
          videoattr(ON);                /* j͔]\ */
          fprintf(stderr, "");
          videoattr(OFF);
          fprintf(stderr, "      y");
     }
     fprintf(stderr, "\n");
     for (i = 0; i < stop; i += 1) {
          if (i > 0)
               fprintf(stderr, SPACE);
          fprintf(stderr, "%s", section);
     }
     fprintf(stderr, "\n");
     before.disp = now.disp = after.disp = 1;
     for (i = 0; i < 6; i += 1) {
          if (nonflag == OFF) {
               priline(i, &before);
               priline(i, &now);
               priline(i, &after);
               fprintf(stderr, "\n");
          } else {
               priline(i, &now);
               fprintf(stderr, "\n");
               if (now.disp > now.last)
                    i = 6;
          }
          if (x_axis != 0) {                 /*  */
               *(space + x_axis - 1) = '\0';
               fprintf(stderr, "%s%s\n", space, SIGN);
               x_axis = 0;
          } else if (i < 6)
               fprintf(stderr, "\n");
     }
     if (nonflag == ON && psopt == ON) {     /* -l IvV */
          cursorattr(OFF);
          fflush(stderr);
          read(STDERR, bf, 1);               /* ʏ STDIN ł */
          cursorattr(ON);
     }
     fprintf(stderr, "\n");
}

void priyear(short i, short j, int func)     /* Ñ^Cg\ */
{
     char bf[6];
     if (i > 1988) {
          sprintf(bf, "%4d", i);
          fprintf(stderr, "['%2s]  %2dN%2d", bf + 2, i - 1988, j);
          fprintf(stderr, func == OFF ? "       " : "\n");       /* SPC7 */
     } else {
          fprintf(stderr, "   %5dN  %2d", i, j);
          fprintf(stderr, func == OFF ? "          " : "\n");    /* SPC10 */
     }
}

void priline(int i, struct set *pd)     /* êPTԕ̕\ */
{
     int j;
     for (j = 1; j <= 7; j += 1) {      /* j`yj܂ */
          if (j == 0) {                 /* ŏ̍s */
               if (j < pd->week)
                    fprintf(stderr, "   ");  /* SPC3 */
               else
                    subpri(i, j, pd);
          } else {                      /* ̑̍s */
               if (pd->disp <= pd->last)
                    subpri(i, j, pd);
               else
                    fprintf(stderr, "   ");  /* SPC3 */
          }
     }
     if (nonflag == OFF)
          fprintf(stderr, "     ");     /* e̊Ԃ͂ASPC5 */
}

void subpri(int i, int j, struct set *pd)    /* \ */
{
     if (j == 1 || holiday(pd, pd->disp) != OFF
                    || (j == 2 && holiday(pd, pd->disp - 1) != OFF)) {
          videoattr(ON);                     /* jՓ͔]\ */
          fprintf(stderr, "%2d", pd->disp);
          videoattr(OFF);
     } else
          fprintf(stderr, "%2d", pd->disp);
     if (j == 7 && nonflag == ON)
          ;
     else
          fprintf(stderr, " ");
     if (function(pd) == ON) {
          if (pd == &before)
               j = 3 * j - 2;
          else if (pd == &now)
               j = (nonflag == OFF) ? 3 *j + 24 : 3 * j - 2;
          else
               j = 3 * j + 50;
          x_axis = j;
     }
     pd->disp += 1;
}

int function(register struct set *pd)   /* uN@\̔ */
{
     return (pd->disp == today->day && pd->month == today->month
                              && pd->year == today->year) ? ON : OFF;
}

int holiday(struct set *pd, register int tempday)      /* x */
{
     int judge;
     switch (pd->month) {     /* eɂ */
     case 1:
          judge = (tempday == 1 || tempday == 15) ? ON : OFF;
          break;
     case 2:
          judge = (tempday == 11) ? ON : OFF;
          break;
     case 3:
          judge = (tempday == 21) ? ON : OFF;
          break;
     case 4:
          judge = (tempday == 29) ? ON : OFF;
          break;
     case 5:
          judge = (tempday >= 3 && tempday <= 5) ? ON : OFF;
          break;
     case 9:
          judge = (tempday == 15 || tempday == 23) ? ON : OFF;
          break;
     case 10:
          judge = (tempday == 10) ? ON : OFF;
          break;
     case 11:
          judge = (tempday == 3 || tempday == 23) ? ON : OFF;
          break;
     case 12:
          judge = (tempday == 23) ? ON : OFF;
          break;
     default:
          judge = OFF;
          break;
     }
     return judge;
}

void chkarg(int argc, char *argv[])     /* ̉ */
{
     int temp;
     char *p;
     nonflag = ON;
     while (--argc) {
          p = argv[argc];
          if (*p == '-') {
               while (*(++p)) {
                    switch (*p) {
                    case 'o':
                         outopt = ON;
                         break;
                    case 'y':
                         if (*(++p) == '=')
                              p++;
                         yopt = atoi(p);
                         if (yopt <= 0)
                              errorline(2);
                         nonflag = OFF;
                         p += strlen(p) - 1;
                         break;
                    case 'm':
                         if (*(++p) == '=')
                              p++;
                         mopt = atoi(p);
                         if (mopt < 1 || mopt > 12)
                              errorline(3);
                         nonflag = OFF;
                         p += strlen(p) - 1;
                         break;
                    case 'L':
                         wopt = ON;
                    case 'l':
                         psopt = ON;
                         break;
                    case 'n':
                         lineopt = ON;
                         break;
                    default:
                         errorline(1);
                         break;
                    }
               }
          } else {
               temp = atoi(p);
               if (temp <= 0)
                    errorline(4);
               nonflag = OFF;
               if (temp <= 12 && temp >= 1)
                    mopt = temp;
               else
                    yopt = temp;
          }
     }
     if ((outopt == ON || psopt == ON ) && (mopt != 0 || yopt != 0))
          errorline(5);
     if (outopt == ON && psopt == ON)
          errorline(6);
}

int errorline(int i)
{
     fprintf(stderr, "   today: %s\n", errcomment[i - 1]);
     exit(i + 10);                 /* for the E program */
}

void syntax(void)
{
     int i;
     for (i = 0; i < NSNTX; i++)
          fprintf(stderr, "\t%s\n", syntxcmt[i]);
}

/* @@肻̑ OS-9 @́AύXĉB@@ */

void videoattr(int func)      /* ̔]\ */
{
     fprintf(stderr, "\x1b[%sm", (func == OFF) ? "27" : "7");
}

void cursorattr(int func)     /* J[\Agr[g */
{
     fprintf(stderr, "\x1b[%1dv", (func == OFF) ? 1 : 0);
}

